#include "c_exit_handling.h"

/* at exit handling */


EIF_OBJ exit_switch = NULL;


#ifdef SE
/* prototype callback function */
void stdc_exit_switch_at_exit(EIF_OBJ obj);
#endif

void epx_the_exit_handler()
{
#ifdef ISE
  EIF_PROCEDURE ep;               
  EIF_TYPE_ID tid;
  tid = eif_type_id ("STDC_EXIT_SWITCH");              
  ep = eif_procedure ("at_exit", tid);
  if (ep == 0)
    { eif_panic ("at_exit feature not found."); }
  else
    { (ep) (eif_access(exit_switch)); }
#endif
#ifdef SE
  if (exit_switch != NULL) {
    stdc_exit_switch_at_exit (exit_switch);
  }
#endif
}


void epx_set_exit_switch (EIF_OBJ a_switch)
{
#ifdef ISE
  /* note that encoding_callback will never be weaned!! */
  exit_switch = eif_adopt (a_switch);
#endif
#ifdef SE
  exit_switch = a_switch;
#endif
  atexit (epx_the_exit_handler);
}

void epx_clear_exit_switch()
{
  exit_switch = NULL;
}
