indexing

   description: "Filters files based on extension."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $";
   revision: "$Revision: #1 $"


class
   
   EXTENSION_FILTER
   
inherit
   
   ABSTRACT_PATH_FILTER
      redefine
         require_status
      end

   
creation
   
   make
   
   
feature -- creation
   
   make (a_extension: STRING) is
         -- `a_extension' includes the '.', so should be something like ".e"
      do
         extension := a_extension
      end
   
   
feature -- state
   
   extension: STRING
   

feature
   
   is_valid (status: ABSTRACT_STATUS; path_name: STRING): BOOLEAN is
      local
         i, j: INTEGER
      do
         from
            i := path_name.count - extension.count + 1
            j := 1
            Result := status.is_regular_file
         until
            not Result or j > extension.count
         loop
            Result := path_name.item (i) = extension.item (j)
            i := i + 1
            j := j + 1
         end
      end
   
   require_status: BOOLEAN is
      -- True if is_valid should get a valid status
      do
         Result := True
      end

   
end
