indexing

   description: "Class that implements whatever an HTTP 1.1 client can do."

   idea: "Support 0.9 HTTP too? Really simple to get just a web page.%
   %Perhaps have a EPX_HTTP_09_CLIENT and make this EXP_HTTP_11_CLIENT.%
   %Now connections are not persistent, support this? Not sure how to handle.%
   %persistent connections while not blocking. With persistent connections%
   %we block until server closes connection when writing stuff."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   EPX_HTTP_CLIENT


inherit

   SUS_BASE


creation

   make


feature -- creation

   make (host_name: STRING) is
      do
         create host.make_from_name (host_name)
         create sa.make (host, http_service)
      end


feature -- methods

   get (url: STRING) is
      local
         request: STRING
      do
         if http /= Void and then http.is_open then
            http.close
         end
         request := sh.make_with_capacity (128)
         request.append_string ("GET ")
         request.append_string (url)
         request.append_string (version)
         request.append_character ('%N')
         request.append_string ("Host: ")
         request.append_string (host.name)
         request.append_character ('%N')
         request.append_string ("Connection: close")
         request.append_string ("%N%N")
         create http.open_by_address (sa)
         debug
            print ("request: ")
            print (request)
            print ("%N")
         end
         http.write_string (request)
      end

   head (url: STRING) is
      local
         request: STRING
      do
         if http /= Void and then http.is_open then
            http.close
         end
         request := sh.make_with_capacity (128)
         request.append_string ("HEAD ")
         request.append_string (url)
         request.append_string (version)
         request.append_character ('%N')
         request.append_string ("Host: ")
         request.append_string (host.name)
         request.append_character ('%N')
         request.append_string ("Connection: close")
         request.append_string ("%N%N")
         create http.open_by_address (sa)
         http.write_string (request)
      end

   options is
      local
         request: STRING
      do
         if http /= Void and then http.is_open then
            http.close
         end
         request := sh.make_with_capacity (128)
         request.append_string ("OPTIONS *")
         request.append_string (version)
         request.append_character ('%N')
         request.append_string ("Host: ")
         request.append_string (host.name)
         request.append_character ('%N')
         request.append_string ("Connection: close")
         request.append_string ("%N%N")
         create http.open_by_address (sa)
         http.write_string (request)
      end


feature -- client http version

   version: STRING is " HTTP/1.1"


feature -- socket

   http: SUS_TCP_SOCKET


feature {NONE} -- private state

   host: SUS_HOST
   sa: SUS_SOCKET_ADDRESS

   http_service: SUS_SERVICE is
      once
         create Result.make_from_name ("http", "tcp")
      end


end
