indexing

   description: "Class that covers the POSIX stream code."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $";
   revision: "$Revision: #1 $"

deferred class

   POSIX_FILE


inherit

   STDC_FILE

   POSIX_BASE

   PAPI_STDIO


feature  -- special makes

   make_from_file_descriptor (a_file_descriptor: ABSTRACT_FILE_DESCRIPTOR;
                              a_mode: STRING) is
         -- open a stream from a given file descriptor
         -- The stream will become remains leading so when the file
         -- descriptor is closed, it will not close, you have to close
         -- the strema to close the file descriptor.
      require
         is_closed: not is_open
         valid_fildes: a_file_descriptor /= Void and then
                       a_file_descriptor.is_open
         -- valid_mode: a_mode is a valid posix mode
      local
         cmode: POINTER
      do
         do_make
         cmode := sh.string_to_pointer (a_mode)
         stream := posix_fdopen (a_file_descriptor.value, cmode)
         if not is_open then
            raise_posix_error
         end
         mode := a_mode
         a_file_descriptor.unown
      ensure
         opened: is_open
         stream_is_leading: not a_file_descriptor.is_owner
      end


end
