/*

Access to Single Unix Specification sys/socket.h

*/

#ifndef _S_SOCKET_H_
#define _S_SOCKET_H_

#define _XOPEN_SOURCE 500

/* FreeBSD likes sys/stat.h */
#include <sys/stat.h>
#include <sys/socket.h>
#include "eiffel.h"


/* functions */

EIF_INTEGER posix_connect (EIF_INTEGER socket, EIF_POINTER address, EIF_INTEGER addr_len);
EIF_INTEGER posix_socket (EIF_INTEGER family, EIF_INTEGER type, EIF_INTEGER protocol);


/* struct sockaddr */

EIF_INTEGER posix_sockaddr_size();

EIF_INTEGER posix_sockaddr_sa_family(struct sockaddr *p);
EIF_POINTER posix_sockaddr_sa_data(struct sockaddr *p);

void posix_set_sockaddr_sa_family(struct sockaddr *p, EIF_INTEGER sa_family);


/* constants */

EIF_INTEGER const_sock_dgram();
EIF_INTEGER const_sock_packet();
EIF_INTEGER const_sock_raw();
EIF_INTEGER const_sock_seqpacket();
EIF_INTEGER const_sock_stream();


/* protocol families */

EIF_INTEGER const_af_inet();


#endif /* _S_SOCKET_H_ */
