indexing

   description: "Class that covers the Single Unix Spec netinet/in.h header."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   SAPI_IN


feature {NONE} -- host to network conversions

   posix_htons (host16bitvalue: INTEGER): INTEGER is
         -- convets value to network byte order
      require
         valid_value: host16bitvalue >= 0 and host16bitvalue <= 65535
      external "C"
      end

   posix_ntohs (host16bitvalue: INTEGER): INTEGER is
         -- converts value to host byte order
      require
         valid_value: host16bitvalue >= 0 and host16bitvalue <= 65535
      external "C"
      end


feature {NONE} -- C binding for members of sockaddr_in

   posix_sockaddr_in_size: INTEGER is
      external "C"
      end

   posix_sockaddr_in_sin_family (a_sockaddr_in: POINTER): INTEGER is
         -- AF_INET
      require
         valid_sockaddr_in: a_sockaddr_in /= default_pointer
      external "C"
      end

   posix_sockaddr_in_sin_port (a_sockaddr_in: POINTER): INTEGER is
         -- Port number.
      require
         valid_sockaddr_in: a_sockaddr_in /= default_pointer
      external "C"
      end

   posix_sockaddr_in_sin_addr (a_sockaddr_in: POINTER): POINTER is
         -- Internet address.
      require
         valid_sockaddr_in: a_sockaddr_in /= default_pointer
      external "C"
      end

   posix_set_sockaddr_in_sin_family (a_sockaddr_in: POINTER; sin_family: INTEGER) is
      require
         valid_sockaddr_in: a_sockaddr_in /= default_pointer
      external "C"
      end

   posix_set_sockaddr_in_sin_port (a_sockaddr_in: POINTER; sin_port: INTEGER) is
      require
         valid_sockaddr_in: a_sockaddr_in /= default_pointer
      external "C"
      end

   posix_set_sockaddr_in_sin_addr (a_sockaddr_in: POINTER; sin_addr: POINTER) is
         -- set sin_addr by moving bytes from `sin_addr'
      require
         valid_sockaddr_in: a_sockaddr_in /= default_pointer
         valid_sin_addr: sin_addr /= default_pointer
      external "C"
      end


end

