indexing

   description: "Class for handling Standard C signals."
   
   usage: "A given handler may be called for multiple signals."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

deferred class 

   STDC_SIGNAL_HANDLER
   

inherit   
   
   STDC_SIGNAL_SWITCH_ACCESSOR

   CAPI_SIGNAL


feature {STDC_SIGNAL_SWITCH} -- main function
   
   signalled (signal_value: INTEGER) is
         -- callback when signal occurs, to be implemented in descendents.      
         -- Note that during the execution of this handler, the
         -- default handler for this signal is in effect. You have to
         -- reestablish the handler if this is not wanted.
      deferred
      end
   

feature {NONE} -- routines that only make sense within `signalled'
   
   reestablish (signal_value: INTEGER) is
         -- when in `signalled' you may want to call this routine, as the
         -- first thing, so your signal handler will be called again if
         -- this signal occurs when you are inside the signal handler.
      local
         r: POINTER
      do
         r := posix_signal (signal_value, signal_switch.handler)
         -- ignore whatever errors
      end


end -- class STDC_SIGNAL_HANDLER
