indexing

   description: "Class that covers Standard C current system info related%
   %routines."

   usage: "Just inherit from this class."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class

   STDC_SYSTEM

inherit

   STDC_BASE

   CAPI_STDLIB


feature -- run-time determined queries

   is_shell_available: BOOLEAN is
         -- Return True if command interpreter is available
      do
         Result := posix_system (default_pointer) /= 0;
      end


feature -- compile time determined queries

   clocks_per_second: INTEGER is
         -- number per second of the value returned by the `clock' function
      external "C"
      alias "const_clocks_per_sec"
      end


feature -- endianess

   is_big_endian: BOOLEAN is
         -- True if this is a big endian architecture
      once
         Result := posix_first_byte (258) = 1 -- 0x0102 == 0x01
      end

   is_little_endian: BOOLEAN is
         -- True if this is a little endian architecture
      once
         Result := not is_big_endian
      end


feature {NONE} -- C bindings

   posix_first_byte (i: INTEGER): INTEGER is
      external "C"
      end


end -- class STDC_SYSTEM
