indexing

   description: "Test all standard POSIX classes. Posix extensions as %
   %semaphores and such are not tested."
   usage: "Change inherit to COMMON_CURRENT_PROCESS if not running %
   %with SmallEiffel under Unix."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class 

   TEST_P_ALL

   
inherit
   
   POSIX_CURRENT_PROCESS

   
creation
   
   make
   
   
feature -- creation

   make is
      local
         test_memory: TEST_P_DYNAMIC_MEMORY
         test_environment: TEST_P_ENVIRONMENT
         test_time: TEST_P_TIME
         test_file_system: TEST_P_FILE_SYSTEM
         test_current_process: TEST_P_CURRENT_PROCESS
         test_system: TEST_P_SYSTEM
         test_group: TEST_P_GROUP
         test_user: TEST_P_USER
         test_file: TEST_P_FILE
         test_file_descriptor: TEST_P_FILE_DESCRIPTOR
         test_nonblock: TEST_P_NONBLOCK
         test_child_process: TEST_P_EXEC_PROCESS
         test_terminal: TEST_P_TERMINAL
         test_modem: TEST_P_MODEM
         test_pipe: TEST_P_PIPE
         test_signal: TEST_P_SIGNAL
      do
         print ("Execute every test.%N")
         
         create test_memory.make
         
         create test_environment.make

         create test_time.make

         create test_file_system.make

         create test_current_process.make
         
         create test_system.make

         create test_group.make
         
         create test_user.make

         create test_file.make

         create test_file_descriptor.make
         
         create test_nonblock.make
         
         create test_child_process.make
         
         create test_signal.make
         
         do_test_fork

         do_test_lock
         
         create test_terminal.make
         
         create test_modem.make
         
         create test_pipe.make
         
         print ("End of all tests.%N")
      end

   do_test_fork is
         -- cygwin doesn't have support for fifo's so this test fails
      local
         test_fork: TEST_P_FORK
         failed: BOOLEAN
      do
         if not failed then
            create test_fork.make
         end
      rescue
         failed := True
         print ("!! test_fork failed.%N")
         retry
      end
   
   do_test_lock is
      local
         test_lock: TEST_P_LOCK
         failed: BOOLEAN
      do
         if not failed then
            create test_lock.make         
         end
      rescue
         failed := True
         print ("!! test_lock failed.%N")
         retry
      end

end -- class TEST_P_ALL
