indexing

	description: "Test Posix pipe."

  author: "Berend de Boer"
	date: "$Date: 2001/12/27 $"
	revision: "$Revision: #1 $"

class TEST_P_PIPE

inherit
   
   POSIX_FORK_ROOT


creation
   
   make



feature
   
   pipe: POSIX_PIPE
   
   
   make is
      local
         stop_sign: Boolean
      do
         print ("Testing Posix pipe interface.%N")

         -- necessary under SmallEiffel
         ignore_child_stop_signal
         
         print ("Create pipe.%N")
         create pipe.make
         
         print ("Fork.%N")
         fork (Current)
         -- close our side of the pipe, else pipe is never closed.
         pipe.fdout.close
         
         from
            stop_sign := False
         until
            stop_sign
         loop
            print ("####%N")
            pipe.fdin.read_string (128)
            print (pipe.fdin.last_string)
            stop_sign := equal(pipe.fdin.last_string, "stop")
         end
         
         print ("Wait for child to terminate.%N")
         wait
         
         pipe.close
         
         print ("End of Posix pipe test.%N")
      end


feature -- forked child   
   
   execute is
      do
         pipe.fdin.close
         pipe.fdout.write_string ("hello ")
         pipe.fdout.write_string ("world.%N")
         -- give reader sometime to read above strings first
         sleep (2)
         pipe.fdout.write_string ("stop")
         -- when we exit, our pipe is automatically closed, so parent gets eof
         -- pipe.fdout.close
      end
   

end -- class TEST_P_PIPE
